
#ifndef A2D_H
#define A2D_H

#define ADC_PRESCALE_DIV2		0x00	///< 0x01,0x00 -> CPU clk/2
#define ADC_PRESCALE_DIV4		0x02	///< 0x02 -> CPU clk/4
#define ADC_PRESCALE_DIV8		0x03	///< 0x03 -> CPU clk/8
#define ADC_PRESCALE_DIV16		0x04	///< 0x04 -> CPU clk/16
#define ADC_PRESCALE_DIV32		0x05	///< 0x05 -> CPU clk/32
#define ADC_PRESCALE_DIV64		0x06	///< 0x06 -> CPU clk/64
#define ADC_PRESCALE_DIV128		0x07	///< 0x07 -> CPU clk/128
#define ADC_PRESCALE			ADC_PRESCALE_DIV64
#define ADC_PRESCALE_MASK		0x07

#define ADC_REFERENCE_AREF		0x00	///< 0x00 -> AREF
#define ADC_REFERENCE_AVCC		0x01	///< 0x01 -> AVCC
#define ADC_REFERENCE_RSVD		0x02	///< 0x02 -> error
#define ADC_REFERENCE_256V		0x03	///< 0x03 -> 2.56V
#define ADC_REFERENCE			ADC_REFERENCE_AVCC
#define ADC_REFERENCE_MASK		0xC0

#define ADC_MUX_MASK			0x1F

#define ADC_CH_ADC0				0x00
#define ADC_CH_ADC1				0x01
#define ADC_CH_ADC2				0x02
#define ADC_CH_ADC3				0x03
#define ADC_CH_ADC4				0x04
#define ADC_CH_ADC5				0x05
#define ADC_CH_ADC6				0x06
#define ADC_CH_ADC7				0x07
#define ADC_CH_122V				0x1E	// 1.22V 
#define ADC_CH_AGND				0x1F	// AGND

#define ADC_CH_0_0_DIFF10X		0x08
#define ADC_CH_1_0_DIFF10X		0x09
#define ADC_CH_0_0_DIFF200X		0x0A
#define ADC_CH_1_0_DIFF200X		0x0B
#define ADC_CH_2_2_DIFF10X		0x0C
#define ADC_CH_3_2_DIFF10X		0x0D
#define ADC_CH_2_2_DIFF200X		0x0E
#define ADC_CH_3_2_DIFF200X		0x0F
#define ADC_CH_0_1_DIFF1X		0x10
#define ADC_CH_1_1_DIFF1X		0x11
#define ADC_CH_2_1_DIFF1X		0x12
#define ADC_CH_3_1_DIFF1X		0x13
#define ADC_CH_4_1_DIFF1X		0x14
#define ADC_CH_5_1_DIFF1X		0x15
#define ADC_CH_6_1_DIFF1X		0x16
#define ADC_CH_7_1_DIFF1X		0x17

#define ADC_CH_0_2_DIFF1X		0x18
#define ADC_CH_1_2_DIFF1X		0x19
#define ADC_CH_2_2_DIFF1X		0x1A
#define ADC_CH_3_2_DIFF1X		0x1B
#define ADC_CH_4_2_DIFF1X		0x1C
#define ADC_CH_5_2_DIFF1X		0x1D

#ifdef ADCSRA
#ifndef ADCSR
	#define ADCSR	ADCSRA
#endif
#endif
#ifdef ADATE
	#define ADFR	ADATE
#endif

void a2dInit(void);

//void a2dOff(void);

void a2dSetPrescaler(unsigned char prescale);

void a2dSetReference(unsigned char ref);

void a2dSetChannel(unsigned char ch);

void a2dStartConvert(void);

unsigned short a2dConvert10bit(void);

#endif
