#define SYSCLK 16

#include <avr/io.h>

#define LCD_RS 	_BV(6);
#define LCD_E 	_BV(7);
#define LCD_STROBE PORTD|=LCD_E;DelayUs(3);PORTD&=~LCD_E;



void DelayUs (unsigned char c)
{
 int i;
 i=SYSCLK*c;
 i=(i >> 2);
 while (i) {
  i--; asm("nop");
 }
}

void DelayMs (unsigned int c)
{
 while (c) {
  c--;
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
 }
 
}




void lcd_write(unsigned char c)
{
	PORTA = (PORTA & 0x0F) |  (c & 0xF0);
	LCD_STROBE
	PORTA = (PORTA & 0x0F) |  (c & 0x0F)<<4;
	LCD_STROBE
	DelayUs(40);
}

void lcd_clear(void)
{
	PORTD&=0xFF-LCD_RS; //LCD_RS = 0;
	lcd_write(0x01);
	DelayMs(2);
}

void
lcd_putcommand(unsigned char c)
{
	PORTD&=(unsigned char)~LCD_RS;
	lcd_write(c);
}


void
lcd_puts(const char * s)
{
	PORTD|=LCD_RS;
	while(*s)
		lcd_write(*s++);
}

void
lcd_putch(unsigned char c)
{
	PORTD|=LCD_RS;
	lcd_write(c);
}


void lcd_init(void)
{
	PORTD&=(unsigned char)~LCD_RS;	
	DelayMs(15);	// power on delay
	PORTA = 0x30;	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	DelayUs(100);
	LCD_STROBE;
	DelayMs(5);
	PORTA = 0x20;	// set 4 bit mode
	LCD_STROBE;
	DelayUs(40);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}


#define LONGY	"\x02"
#define LONGA	"\x01"

//#define LONGI	"\x04"
#define HACC	"\x05"
#define HACE	"\x06"
#define LONGI	"\x07"


void lcd_cursoroff() {
 lcd_putcommand(0x0C);
}

void lcd_setCZuserchars()
{
 char i;
 lcd_putcommand(0x40);
 for (i=0;i<=7;i++) {lcd_putch(0x10);}
 
 //dlouhe a 
 lcd_write(0x02);
 lcd_write(0x04);
 lcd_write(0x0E);
 lcd_write(0x01);
 lcd_write(0x0F);
 lcd_write(0x11);
 lcd_write(0x0F);
 lcd_write(0x00); 
 //dlouhe y
 lcd_write(0x02);
 lcd_write(0x04);
 lcd_write(0x11);
 lcd_write(0x11);
 lcd_write(0x0F);
 lcd_write(0x01);
 lcd_write(0x0E);
 lcd_write(0x00);
 
 for (i=0;i<=7;i++) {lcd_write(0x1E);}
 //dlouhe i
 lcd_write(0x02);
 lcd_write(0x04);
 lcd_write(0x0C);
 lcd_write(0x04);
 lcd_write(0x04);
 lcd_write(0x04);
 lcd_write(0x0E);
 lcd_write(0x00);
 //c s hackem
 lcd_write(0x0A);
 lcd_write(0x04);
 lcd_write(0x0E);
 lcd_write(0x10);
 lcd_write(0x10);
 lcd_write(0x11);
 lcd_write(0x0E);
 lcd_write(0x00);
 //e s hackem
 lcd_write(0x0A);
 lcd_write(0x04);
 lcd_write(0x0E);
 lcd_write(0x11);
 lcd_write(0x1E);
 lcd_write(0x10);
 lcd_write(0x0E);
 lcd_write(0x00);
 //i dlouhe
 lcd_write(0x02);
 lcd_write(0x04);
 lcd_write(0x0C);
 lcd_write(0x04);
 lcd_write(0x04);
 lcd_write(0x04);
 lcd_write(0x0E);
 lcd_write(0x00); 
 lcd_putcommand(0x80);
}



